-- tits = 33 % 2232
-- outputChatBox ( tits ) 

local root = getRootElement()
	local ids = { 2780, 701, 702 }	-- fog machine, tumbleweed 1/2
local pieces = { height = 20,		-- shouldn't be 0
				width = 10,			-- top radius
				thickness = 0.1,	-- 0 < * ( 1 being the width )
				fog = .75,			-- between 0 and 1
				count = 100 }		-- including fogmachines
-- local previous = { fog = pieces.fog,
				   -- count = pieces.count }

function setOption ( field, value )
	pieces[field] = value
end

function getOption ( field )
	return pieces[field]
end

function randomObject ( spacing, majorityIsFogMachines )	
	if majorityIsFogMachines == false then
		if spaceCount == spacing then
			spaceCount = 0
			-- fogCount = fogCount + 1 --debug
			-- outputChatBox ( "fogCount = "..fogCount ) --debug
			return ids[1]
		else
			spaceCount = spaceCount + 1
			-- tumbleCount = tumbleCount + 1 --debug
			-- outputChatBox ( "tumbleCount = "..tumbleCount ) --debug		
			return ids[math.random ( 2, #ids )]	
		end
	elseif majorityIsFogMachines == true then --When over fifty, tumble weed becomes what is spaced, not fog machines
		if spaceCount == spacing then
			spaceCount = 0			
			-- tumbleCount = tumbleCount + 1 --debug
			-- outputChatBox ( "tumbleCountB = "..tumbleCount ) --debug	
			return ids[math.random ( 2, #ids )]
		else
			spaceCount = spaceCount + 1
			-- fogCount = fogCount + 1 --debug
			-- outputChatBox ( "fogCountB = "..fogCount ) --debug
			return ids[1]
		end		
	end
end

function getRandomPositionOffsets ( x, y, z )
	local a, b = -1, 1
	x, y, z = x + randFloat ( a, b ), y + randFloat ( a, b ), z + randFloat ( a, b )
	return x, y, z
end

function getRandomRotationOffsets()
	local rx, ry, rz = math.random ( 0, 10 ), math.random ( 0 , 10 ), math.random ( 0 , 5 )
	return rx, ry, rz
end

function getRandomAngleOffsets()
	local angle1, angle2 = randFloat ( 0.005, 0.1 ), randFloat ( 0.01, 0.03 )
	return angle1, angle2
end

function randFloat ( a, b )
	return a + math.random() * ( b - a )
end

function updateElementsPosition()
	local count = #pieces
	if ( count > 0 ) then
		for i=1, count do
			local piece = pieces[i]
			local object = piece.object
			
			local oldPosX, oldPosY, oldPosZ = getElementPosition ( object )
			local oldRotX, oldRotY, oldRotZ = getElementRotation ( object )
			local posXOffset, posYOffset, posZOffset = piece.posXOffset, piece.posYOffset, piece.posZOffset
			local tx, ty, tz = getElementPosition ( pieces.dummyTornado )
			local height, width, thickness = pieces.height, pieces.width, pieces.thickness
			
			local newRotX, newRotY, newRotZ = oldRotX + piece.rotXOffset, oldRotY + piece.rotYOffset, oldRotZ + piece.rotZOffset
			local newAngle1, newAngle2 = piece.angle1 + piece.angle1Offset, piece.angle2 + piece.angle2Offset
			
			local newWidth = width * ( 1 + thickness - math.cos ( math.asin ( ( oldPosZ - posZOffset - tz ) / ( height * 1.05 ) ) ) )
			local newPosX = tx + posXOffset + newWidth * ( math.cos ( newAngle1 ) )
			local newPosY = ty + posYOffset + newWidth * ( math.sin ( newAngle1 ) )
			local newPosZ = tz + posZOffset + ( height / 2 ) * ( 1 + math.sin ( newAngle2 ) )
			
			piece.angle1 = ( newAngle1 > 2 * math.pi ) and ( newAngle1 - 2 * math.pi ) or newAngle1
			piece.angle2 = ( newAngle2 > 2 * math.pi ) and ( newAngle2 - 2 * math.pi ) or newAngle2
			
			setElementPosition ( object, newPosX, newPosY, newPosZ )
			setElementRotation ( object, newRotX, newRotY, newRotZ )
		end
	end
end

function createTornadoPiece ( i, spacing, majorityIsFogMachines )
	if ( i ) then
		local tx, ty, tz = getElementPosition ( pieces.dummyTornado )
		local piece = {}
		local model = randomObject ( spacing, majorityIsFogMachines )
		piece.object = createObject ( model, tx, ty, tz, rx, ry, rz )
		piece.posXOffset, piece.posYOffset, piece.posZOffset = getRandomPositionOffsets ( tx, ty, tz )
		piece.rotXOffset, piece.rotYOffset, piece.rotZOffset = getRandomRotationOffsets()
		piece.angle1Offset, piece.angle2Offset = getRandomAngleOffsets()
		piece.angle1, piece.angle2 = piece.angle1Offset, - math.pi / 2
		pieces[i] = piece
		if model == 2780 then --fog machine
			setTimer ( setElementAlpha, 500, 1, piece.object, 0 ) 
		end
		setTimer ( setElementCollidableWith, 500, 1, getLocalPlayer(), piece.object, false )
	else 
		return false
	end
end

function createTornado()
	outputChatBox ( "Tornado started." )
	pieces.dummyTornado = source
	onStart() --!!
end

addEvent ( "onTornado", true )
addEventHandler ( "onTornado", root, createTornado )

function destroyTornado()
	local timers = getTimers ()
	for k, v in ipairs(timers) do
		  killTimer ( v )
	end
	removeEventHandler ( "onClientRender", root, updateElementsPosition )
	for i=1, #pieces do
		local object = pieces[i].object
		destroyElement ( object )
		pieces[i] = nil
	end
end

addEvent ( "onTornadoStop", true )
addEventHandler ( "onTornadoStop", root, destroyTornado )

function onStart()
	-- tumbleCount = 0 --debug
	-- fogCount = 0 --debug

	tornadoRender = addEventHandler ( "onClientRender", root, updateElementsPosition )
	local fogMachines = math.floor(pieces.count * pieces.fog) --Percentage of objects to be fog machines
	local tumbleWeeds = math.floor(pieces.count * (1-pieces.fog))
	local spacing = math.floor(tumbleWeeds / fogMachines)
	local majorityIsFogMachines = false 
	spaceCount = 0
	if spacing < 1 then
		majorityIsFogMachines = true
		spacing = math.floor(fogMachines / tumbleWeeds)
	end
	--debug
	-- outputChatBox ( "pieces.fog = "..pieces.fog )
	-- outputChatBox ( "pieces.count = "..pieces.count )
	-- outputChatBox ( "fogMachines = "..fogMachines )
	-- outputChatBox ( "tumbleWeeds = "..tumbleWeeds )
	-- outputChatBox ( "majorityIsFogMachines == "..tostring(majorityIsFogMachines) )	
	-- outputChatBox ( "spacing = "..spacing )
	--debug
	for i=1, pieces.count do
		setTimer ( createTornadoPiece, i * 50, 1, i, spacing, majorityIsFogMachines )
	end
end

function clientPlayerJoin ()
	setTimer ( function ()
		if not tornadoRender then
			onStart(source)
		end
	end, 1000, 1 )
end
addEventHandler ( "onClientResourceStart", getResourceRootElement ( getThisResource() ), clientPlayerJoin )

--addEventHandler ( "onClientResourceStart", getResourceRootElement ( getThisResource() ), onStart )
--local newPosX = tx + pieces[i].posXOffset + pieces.width * ( 1 + thickness - math.cos ( math.asin ( ( oldPosZ - posZOffset - tz ) / ( height * 1.05 ) ) ) ) * ( math.cos ( pieces[i].angle1 + pieces[i].angle1Offset ) )